<ui:composition xmlns:rich="http://richfaces.org/rich" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- parameters: managedBean, title,
         inserts: sutSelection, transactionSelection, editQueryParameters, displayQueryParameters, patientDetails, testReport -->
    <h:form id="globalForm">
        <h1>
            <h:outputText value="#{title}"/>
        </h1>
        <s:div id="globalDiv">
            <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                <ui:define name="panel_title">#{title}</ui:define>
                <ui:insert name="sutSelection"/>
                <ui:include src="/testData/_testDataSelection.xhtml">
                    <ui:param name="managedBean" value="#{managedBean}"/>
                    <ui:param name="idsToRender" value="globalDiv"/>
                </ui:include>
                <ui:insert name="transactionSelection"/>
                <s:div rendered="#{managedBean.displayCriteriaForm and managedBean.selectedTestData == null}"
                       id="criteriaSelectionDiv">
                    <ui:insert name="editQueryParameters"/>
                </s:div>
                <gri:panel id="viewParamPanel"
                           rendered="#{not managedBean.displayCriteriaForm or managedBean.selectedTestData != null}">
                    <f:facet name="header">
                        <h:outputText value="#{messages['gazelle.simulator.pam.QueryParameters']} "/>
                        <a4j:commandLink actionListener="#{managedBean.unselectTestData()}"
                                         rendered="#{managedBean.selectedTestData != null}" render="globalDiv">
                            <s:span styleClass="gzl-icon-times-circle" title="Unselect pre-defined query"/>
                        </a4j:commandLink>
                    </f:facet>
                    <ui:insert name="displayQueryParameters"/>
                </gri:panel>
                <s:div rendered="#{not managedBean.displayCriteriaForm}"
                       id="responseDiv">
                    <s:decorate template="/layout/panels/_panel_title.xhtml"
                                rendered="#{not empty managedBean.receivedPatients}"
                                id="allPatientsPanel">
                        <ui:define name="panel_title">#{messages['gazelle.simulator.pam.ReturnedPatients']}</ui:define>
                        <dl class="dl-horizontal">
                            <s:decorate template="/layout/display/_display.xhtml">
                                <ui:define name="label">#{messages['gazelle.simulator.pam.PageNumber']}</ui:define>
                                <a4j:repeat value="#{managedBean.pages}" var="pageNb">
                                    <a4j:commandLink value="#{pageNb}"
                                                     actionListener="#{managedBean.setSelectedPage(pageNb)}"
                                                     rendered="#{not managedBean.selectedPage.equals(pageNb)}"
                                                     render="allPatientsPanel"/>
                                    <h:outputText value="#{pageNb}" style="font-weight:bold;"
                                                  rendered="#{managedBean.selectedPage.equals(pageNb)}"/>
                                    <h:outputText value=" | "/>
                                </a4j:repeat>
                            </s:decorate>
                        </dl>
                        <s:decorate template="/patient/_patientTable.xhtml"
                                    rendered="#{not empty managedBean.receivedPatients}">
                            <ui:param name="patients" value="#{managedBean.receivedPatients}"/>
                            <ui:define name="rightColumns">
                                <g:column>
                                    <ui:define name="header">#{messages['gazelle.simulator.pam.Action']}</ui:define>
                                    <div class="gzl-never-wrap">
                                        <a4j:commandLink
                                                actionListener="#{managedBean.setSelectedPatient(patient)}"
                                                oncomplete="jq162('#patientDetailsModalPanel').modal('show');"
                                                render="detailContent"
                                                title="#{messages['gazelle.simulator.pam.PatientDetails_2']}">
                                            <s:span styleClass="gzl-icon-search "/>
                                        </a4j:commandLink>
                                        <a4j:commandLink actionListener="#{managedBean.storePatient(patient)}"
                                                         render="messages"
                                                         title="#{messages['gazelle.simulator.pam.SavePatientInPDCsDB']}">
                                            <s:span styleClass="gzl-icon-save "/>
                                        </a4j:commandLink>
                                    </div>
                                </g:column>
                            </ui:define>
                        </s:decorate>
                    </s:decorate>
                    <ui:insert name="patientDetails"/>
                    <s:div
                            rendered="#{empty managedBean.receivedPatients and managedBean.cancellation == null}">
                        <h:outputText
                                value="#{messages['gazelle.simulator.pam.ThisQueryHasReturnedNoResult']}"
                                styleClass="gzl-alert gzl-alert-orange"/>
                    </s:div>
                    <s:div rendered="#{managedBean.cancellation != null}">
                        <h:outputText
                                value="#{messages['gazelle.patientmanager.QueryHasBeenSuccessfullyCancelled']}"
                                styleClass="gzl-alert gzl-alert-green"/>
                    </s:div>
                    <h:outputText value="#{messages['gazelle.simulator.pam.MoreResultsAreAvailableOnSupplierSide']}"
                                  styleClass="gzl-alert gzl-alert-green"
                                  rendered="#{managedBean.moreResultsAvailable and not empty managedBean.receivedPatients}"/>
                    <ui:decorate template="/layout/panels/_panel_title.xhtml">
                        <ui:define name="panel_title">#{messages['gazelle.simulator.pam.TestReport']}</ui:define>
                        <ui:insert name="testReport"/>
                    </ui:decorate>
                </s:div>
                <ui:define name="panel_footer">
                    <a4j:commandButton value="#{messages['gazelle.simulator.pam.SendMessage']}"
                                       actionListener="#{managedBean.sendMessage()}"
                                       render="globalDiv" rendered="#{managedBean.displayCriteriaForm}"
                                       styleClass="gzl-btn-blue" execute="@form"/>
                    <a4j:commandButton value="#{messages['gazelle.patientmanager.CheckCancellation']}"
                                       actionListener="#{managedBean.cancelQuery()}"
                                       styleClass="gzl-btn-blue"
                                       rendered="#{managedBean.cancellation}" render="globalDiv"/>
                    <a4j:commandButton value="#{messages['gazelle.simulator.pam.GetNextResults']}"
                                       actionListener="#{managedBean.getNextResults()}"
                                       render="responseDiv" styleClass="gzl-btn-blue"
                                       rendered="#{managedBean.moreResultsAvailable and not empty managedBean.receivedPatients}"/>
                    <a4j:commandButton value="#{messages['gazelle.simulator.pam.CancelQuery']}"
                                       actionListener="#{managedBean.cancelQuery()}"
                                       render="globalDiv" styleClass="gzl-btn-blue"
                                       rendered="#{not (managedBean.selectedTransaction.keyword.equals('ITI-78'))
                                        and managedBean.moreResultsAvailable and not empty managedBean.receivedPatients}"/>
                    <a4j:commandButton value="#{messages['gazelle.simulator.pam.PerformAnotherTest']}"
                                       actionListener="#{managedBean.initializeRequest()}"
                                       render="globalDiv" styleClass="gzl-btn-blue"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.AddQueryToFavorite']}"
                                       actionListener="#{managedBean.createNewTestData()}"
                                       oncomplete="jq162('#saveTestData').modal('show')"
                                       render="testMetadataContent"
                                       rendered="#{identity.loggedIn and managedBean.selectedTestData == null}"
                                       styleClass="gzl-btn-green"/>
                </ui:define>
            </ui:decorate>
            <ui:include src="/testData/_testDataMetadata.xhtml">
                <ui:param name="managedBean" value="#{managedBean}"/>
            </ui:include>
        </s:div>
    </h:form>
</ui:composition>